#define _H_ADGMTypes

/*
 *  Copyright Jeff Francis 1990
 * All rights reserved
 *
 * This interface is based on material copyrighted
 * by Berkeley Systems, Inc. 1989-1990.
 *
 * $Id$
 *
 * Description - Contains enumerations, typedefs and defines for a
 * 'ADgm' code resource.  Page references are to "After Dark
 * Programmer's Manual." 
 *
 */

#include <QuickDraw.h>
#include <SoundMgr.h>

typedef enum {				/* Page 17 - More About Messages */
	kInitialize = 0,			/* Page 17 */
	kBlank = 2,					/* Page 18 */
	kDrawFrame = 3,				/* Page 18 */
	kClose = 1,					/* Page 18 */
	kButtonMessage = 8,			/* Page 18 */
	kModuleSelected = 4,		/* Page 18 */
	kDoHelp = 5					/* Page 18 */
};
typedef short eMessage;

typedef enum {					/* Page 18 - Graphics Module Return Values */
	kModuleError = -1,			/* Page 18 */
	kRestartMe = 1,				/* Page 19 */
	kImDone = 2,				/* Page 19 */
	kRefreshResources = 3		/* Page 19 */
} eReturn;

typedef struct MonitorData {	/* Page 20 - monitors */
	Rect	bounds;					/* Page 20 */
	Boolean	synchFlag;				/* Page 20 */
	char	curDepth;				/* Page 20 */
} MonitorData, *MonitorDataPtr, **MonitorDataHdl;

typedef struct MonitorsInfo {	/* Page 20 - monitors */
	short		monitorCount;		/* Page 20 */
	MonitorData	monitorList[1];		/* Page 20 */
} MonitorsInfo, *MonitorsInfoPtr, **MonitorsInfoHdl;

								/* Page 20 - systemConfig */
#define cqdAvail		0x0001		/* Page 20 */
#define anyMultibit		0x0002		/* Page 20 */
#define allMultibit		0x0004		/* Page 20 */
#define anyColor		0x0008		/* Page 20 */
#define allColor		0x0010		/* Page 20 */
#define anyCLUTDevice	0x0020		/* Page 20 */
#define allCLUTDevice	0x0040		/* Page 20 */
#define allCanDim		0x0080		/* Page 20 */
#define mainMonCanDim	0x0100		/* Page 20 */
#define soundAvail		0x8000		/* Page 20 */

typedef struct QDGlobals {		/* Page 21 - gdGlobalsCopy */
	GrafPtr		qdThePort;			/* Page 21 */
	Pattern		qdWhite;			/* Page 21 */
	Pattern		qdBlack;			/* Page 21 */
	Pattern		qdGray;				/* Page 21 */
	Pattern		qdLtGray;			/* Page 21 */
	Pattern		qdDkGray;			/* Page 21 */
	Cursor		qdArrow;			/* Page 21 */
	BitMap		qdScreenBits;		/* Page 21 */
	long		qdRandSeed;			/* Page 21 */
} QDGlobals, *QDGlobalsPtr, **QDGlobalsHdl;

typedef struct GMParamBlock {	/* Page 19 - Graphics Modules Parameters */
	short				controlValues[4];	/* Page 19 */
	MonitorsInfoPtr		monitors;			/* Page 20 */
	Boolean				colorQDAvail;		/* Page 20 */
	short				systemConfig;		/* Page 20 */
	QDGlobalsPtr		qdGlobalsCopy;		/* Page 21 */
	short				brightness;			/* Page 21 */
	Rect				demoRect;			/* Page 21 */
	StringPtr			errorMessage;		/* Page 21 */
	SndChannelPtr		sndChannel;			/* Page 21 */
	short				adVersion;			/* Page 22 */
} GMParamBlock, *GMParamBlockPtr, **GMParamBlockHdl;