/* Copyright 1992.  Adobe Systems, Inc.. All rights reserved. */

#include "Types.r"
#include "Systypes.r"
#include "PIGeneral.r"

/*	Dialog IDs */

#define IDD_ABOUT       16000


/* Version information. */

#ifndef Version

#define Version "1.0"

resource 'vers' (1, purgeable)
	{
	1, 0, final, 0, verUs,
	Version,
	Version " 1989-93 Adobe Systems, Inc."
	};

#endif

resource 'PiMI' (16000, purgeable)
{
	latestFormatVersion, 	/* Version, subVersion, and priority of the interface */
	latestFormatSubVersion,
	0,
	supportsBitMap +
	supportsGrayScale +
	supportsIndexedColor +
	supportsRGBColor +
	supportsCMYKColor +
	supportsHSLColor +
	supportsHSBColor +
	supportsMultichannel +
	supportsDuotone +
	supportsLABColor,			/* Supported Image Modes */
	'    ',						/* Required host */
	
	{
		canRead,
		cannotReadAll,
		canWrite,
		canWriteIfRead,
		savesResources,
		{  1, 16, 16, 16,		/* Maximum # of channels for each plug-in mode */
		  16, 16, 16, 16,
		  16, 16,  0,  0,
		   0,  0,  0,  0 },
		32767,				/* Maximum rows allowed in document */
		32767,				/* Maximum columns allowed in document */
		'8BsF',				/* The file type if we create a file. */
		'8BIM',				/* The creator type if we create a file. */
		{					/* The type-creator pairs supported. */
			'8BsF', '    '
		},
		{					/* The extensions supported. */
		}
	},
	
	{}

};


/* About box */

resource 'DLOG' (IDD_ABOUT, purgeable) {
	{20, 0, 144, 260},
	dBoxProc,
	visible,
	noGoAway,
	0x0,
	IDD_ABOUT,
	""
};

resource 'DITL' (IDD_ABOUT, purgeable) {
	{	/* array DITLarray: 4 elements */
		/* [1] */
		{-8192, -8192+1, -8192, -8192+1},	/* Invisible, but something to accept 'Enter' */
		Button {
			enabled,
			""
		},
		/* [2] */
		{0, 0, 124, 260},					/* Click anywhere to dismiss */
		UserItem {
			enabled
		},
		/* [3] */
		{10, 10, 26, 250},
		StaticText {
			disabled,
			"Dump File Format"
		},
		/* [4] */
		{28, 10, 44, 250},
		StaticText {
			disabled,
			" 1992-1993 Adobe Systems, Inc."
		},
		/* [5] */
		{46, 10, 62, 250},
		StaticText {
			disabled,
			"version " Version
		},
		/* [6] */
		{66, 10, 120, 250},
		StaticText {
			disabled,
			"A plug-in image format module that reads"
			" and writes Dump Format files"
		}
	}
};

