/*
 * config.h for the Macintosh
 *
 * Copyright (C) 1993, 1994 Marc Parmet.
 * This file is part of the Macintosh port of GNU Emacs.
 *
 * GNU Emacs is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#include "s-mac.h"
#include "m-mac.h"

/* Load in the conversion definitions if this system
   needs them and the source file being compiled has not
   said to inhibit this.  There should be no need for you
   to alter these lines.  */

#ifdef SHORTNAMES
#ifndef NO_SHORTNAMES
#include "../shortnames/remap.h"
#endif /* not NO_SHORTNAMES */
#endif /* SHORTNAMES */

/* Define HAVE_X_WINDOWS if you want to use the X window system.  */

/* #define HAVE_X_WINDOWS */

/* Define X11 if you want to use version 11 of X windows.
   Otherwise, Emacs expects to use version 10.  */

#ifdef HAVE_X_WINDOWS
#define X11
#endif

/* Define HAVE_X_MENU if you want to use the X window menu system.
   This appears to work on some machines that support X
   and not on others.  */

/* #define HAVE_X_MENU */

/* Define `subprocesses' should be defined if you want to
   have code for asynchronous subprocesses
   (as used in M-x compile and M-x shell).
   These do not work for some USG systems yet;
   for the ones where they work, the s-*.h file defines this flag.  */

#ifndef VMS
#ifndef USG
#define subprocesses
#endif
#endif

/* Define USER_FULL_NAME to return a string
   that is the user's full name.
   It can assume that the variable `pw'
   points to the password file entry for this user.

   At some sites, the pw_gecos field contains
   the user's full name.  If neither this nor any other
   field contains the right thing, use pw_name,
   giving the user's login name, since that is better than nothing.  */

#define USER_FULL_NAME pw->pw_name

/* Define AMPERSAND_FULL_NAME if you use the convention
   that & in the full name stands for the login id.  */

/* #define AMPERSAND_FULL_NAME */

/* # bytes of pure Lisp code to leave space for. */

#define PURESIZE 230000

/* Define HIGHPRI as a negative number
   if you want Emacs to run at a higher than normal priority.
   For this to take effect, you must install Emacs with setuid root.
   Emacs will change back to the users's own uid after setting
   its priority.  */

/* #define HIGHPRI */

/*********************
 * Added for the Mac *
 *********************/

#define SYSTEM_MALLOC				/* Use our own malloc */
#define MIN_STACK_SIZE 64			/* Need more stack than default */
#define VALBITS 26					/* Make address space as large as possible */
#define GCTYPEBITS (32-1-VALBITS)	/* Minus one for the mark bit */
#define SYMS_SYSTEM syms_of_apple()

#if 0

/* Some uses of bit field instructions.  I wonder if they really speed things up. */

#define XINT(X) _xint(X)
#pragma parameter __D0 _xint(__D0)
/* bfexts d0{6:26},d0 */
int _xint(int x) = { 0xEBC0, ((INTBITS-VALBITS)<<6) + VALBITS };

#define XSET(var,type,val) ((var) = _xset((int)type,(int)val))
#pragma parameter __D0 _xset(__D1,__D0)
/* bfins d1,d0{0:6} */
int _xset(int type,int val) = { 0xEFC0, 0x1000 + (INTBITS-VALBITS) };

#define XGCTYPE(X) _xgctype(X)
#pragma parameter __D0 _xgctype(__D0)
/* bfextu d0{1:5},d0 */
int _xgctype(int x) = { 0xE9C0, (1<<6) + GCTYPEBITS };

#endif
