/*
 * This file is part of a Macintosh port of GNU Emacs.
 * Copyright (C) 1993, 1994 Marc Parmet.  All rights reserved.
 *
 * GNU Emacs is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#ifndef __SYS_DIR__
#define __SYS_DIR__

#include "sys/param.h"

#if defined(powerc)
#pragma options align=mac68k
#endif

struct direct {
	char d_name[MAXNAMLEN];		// name of file, C string
	unsigned short d_namlen;	// length of above C string
	long d_ino;					// To keep Emacs happy, always set to 1.
};

typedef struct DIR {
	char dd_volumes;
	short dd_vRefNum;
	long dd_drDirID;
	int dd_index;
} DIR;

#if defined(powerc)
#pragma options align=reset
#endif

extern DIR *opendir();
extern struct direct *readdir();
extern int closedir();

#endif
