/*
 * This file is part of a Macintosh port of GNU Emacs.
 * Copyright (C) 1993, 1994 Marc Parmet.  All rights reserved.
 *
 * GNU Emacs is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#ifndef __SYS_STAT__
#define __SYS_STAT__

#define	S_IFMT	0170000		/* type of file */
#define S_IFDIR	0040000		/* directory */
#define S_IFCHR	0020000		/* character special */
#define S_IFBLK	0060000		/* block special */
#define S_IFREG	0100000		/* regular */
#define S_IFIFO	0010000		/* fifo */
#define S_IFNAM 0050000		/* special named file */
#define S_IFLNK	0030000		/* alias file */

#define S_IREAD 	0400
#define S_IWRITE	0200
#define S_IEXEC		0100

#if defined(powerc)
#pragma options align=mac68k
#endif

struct stat {
	int st_ino;
	int st_uid;
	int st_gid;
	int st_nlink;
	int st_atime;
	int st_ctime;
	unsigned short st_mode;
	int st_mtime;
	int st_size;
	int st_rdev;
};

#if defined(powerc)
#pragma options align=reset
#endif

#endif
