(defun tc:file-in-project-p (file-string)
  (let* ((null-desc (make-string sizeof-AEDesc 0))
		 have-null-desc
		 (file-desc (make-string sizeof-AEDesc 0))
		 (reply (make-string sizeof-AppleEvent 0))
		 have-file-desc
		 (file-obj (make-string sizeof-AEDesc 0))
		 have-file-obj
		 event
		 have-reply
		 transactionID
		 (result-data (make-string 1 0))
		 (result-type (make-string 4 0))
		 (result-size (make-string 4 0))
		 (result
		  (catch 'panic
			(throw-err (create-think-c-apple-event kAECoreSuite kAEDoObjectsExist
												   event transactionID))
			
			(throw-err (AECreateDesc typeNull "" 0 null-desc))
			(setq have-null-desc t)
			(throw-err (AECreateDesc typeChar file-string (length file-string) file-desc))
			(setq have-file-desc t)
			(throw-err (CreateObjSpecifier cSourceFile null-desc formName file-desc
										   0 file-obj))
			(setq have-file-obj t)
			(throw-err (AEPutParamDesc event keyDirectObject file-obj))
			
			(throw-err (AESend event reply (+ kAEWaitReply kAENeverInteract)
							   kAENormalPriority kAEDefaultTimeout
							   AESend-idle-function 0))
			(setq have-reply t)
			
			(throw-err (AEGetParamPtr reply keyAEResult typeBoolean result-type
									  result-data 1 result-size))
			(not (zerop (extract-internal result-data 0 'char))))))
    
    (if have-null-desc (AEDisposeDesc null-desc))
    (if have-file-desc (AEDisposeDesc file-desc))
    (if have-file-obj (AEDisposeDesc file-obj))
    (if event (AEDisposeDesc event))
    (if have-reply (AEDisposeDesc reply))
    result))

(defun tc:relevant-buffers ()
  (let ((old-buffer (current-buffer))
		(result nil)
		(blist (buffer-list)))
	(while blist
	  (let* ((buffer (car blist))
			 (filename (buffer-file-name buffer)))
		(set-buffer buffer)
				;(if tc:have-TPM-data)
				;(if (and filename
				;		 (tc:file-in-project-p (file-name-nondirectory
				;                               (buffer-file-name buffer)))))
		(if filename
			(setq result (cons (list buffer (buffer-file-name buffer)
									 (buffer-modified-p buffer))
							   result)))
		(setq blist (cdr blist))))
	(set-buffer old-buffer)
	result))
