/*********************************************************************
Project	:	MacPerl			-	Real Perl Application
File		:	MPFile.h			-
Author	:	Matthias Neeracher

A lot of this code is borrowed from 7Edit written by
Apple Developer Support UK

Started	:	17Mar93								Language	:	MPW C
Modified	:	17Mar93	MN
				29May93	MN	Compiles correctly
				13Aug93	MN	ApplySettings
				29Aug93	MN	GetDocType
Last		:	29Aug93
*********************************************************************/

#ifndef __MPFILE__
#define __MPFILE__

#include <Memory.h>
#include <QuickDraw.h>
#include <Traps.h>
#include <Files.h>
#include <Packages.h>
#include <Editions.h>
#include <AppleEvents.h>
#include <Printing.h>

#include "MPGlobals.h"
#include "MPUtils.h"
#include "MPWindow.h"
#include "MPEditions.h"

pascal void DoQuit(DescType saveOpt);

pascal OSErr DoClose(WindowPtr aWindow, Boolean canInteract, DescType dialogAnswer);

pascal OSErr GetFileNameToSaveAs(DPtr theDocument);

pascal OSErr GetFileContents(FSSpec theFSSpec, DPtr theDocument);

pascal void FileError(Str255 s, Str255 f);

pascal OSErr SaveAskingName(DPtr theDocument, Boolean canInteract);

pascal OSErr SaveUsingTemp(DPtr theDocument);

pascal OSErr DoCreate(FSSpec theSpec);

pascal OSErr OpenOld(FSSpec aFSSpec, DocType type);

pascal OSErr GetFile(FSSpec *theFSSpec);

pascal void ApplySettings(DPtr doc, HPtr settings);

pascal OSErr SaveConsole(DPtr doc);

pascal void RestoreConsole(DPtr doc);

pascal DocType GetDocType(FSSpec * spec);

#endif