/*********************************************************************
Project	:	MacPerl		-	Real Perl Application
File		:	MPRsrc.h		-	Resources
Author	:	Matthias Neeracher
Started	:	17Aug93								Language	:	MPW C
Modified	:	17Aug93	MN	Protect against multiple inclusion
				27Aug93	MN	Format
				07Nov93	MN	Further work on preference dialog
Last		:	07Nov93
*********************************************************************/

#ifndef __MPRSRC__
#define __MPRSRC__

#define  MPAppSig 'McPL'
#define	MPRtSig	'MrPL'

/* Window templates */

#define	WindowTemplates   128

/* Dialogs & Alerts */

#define  ErrorAlert   		256
#define  SaveAlert  			257
#define	AboutDialog			258
#define	RevertAlert			262
#define	AbortAlert			266
#define	NoPerlAlert			270
#define	ElvisAlert			274

#define	FormatDialog		320

#define	fd_OK					1
#define	fd_Cancel			2
#define	fd_FontList			3
#define	fd_SizeList			4
#define	fd_Separator		5
#define	fd_Outline			6
#define	fd_SizeEdit			7
#define	fd_MakeDefault		8

#define	PrefDialog			384

#define	pd_LibIcon			1
#define	pd_ScriptIcon		2
#define	pd_Boundary			3
#define	pd_Done				4
#define	pd_Outline			5

#define	pd_LibStr			1
#define	pd_ScriptStr		2
#define	pd_ChangePath		3
#define	pd_AddPath			4

#define	PrefLibID			385

#define	pld_List 			pd_Outline+1
#define	pld_Remove			pd_Outline+2
#define	pld_Add				pd_Outline+3

#define	PrefLibDelID		3850

#define	PrefScriptID		386

#define	psd_Edit				pd_Outline+1
#define	psd_Run				pd_Outline+2
#define	psd_Check			pd_Outline+3

#define	GetScriptDialog	512

#define	SaveScriptDialog	192
#define 	ssd_Type				13
/* 
	Small Icons
*/

#define 	ConsoleSICNID	256
#define 	DocumentSICNID	257
#define 	EnabledSICNID	264
#define 	ReadOnlySICNID	265
#define 	BlockedSICNID	266

/* 
	Credits font and strings
*/

#define CreditID	32268

/*
	Menu Resources
*/

#define  appleID	128
#define  fileID	129
#define  editID	130
#define	windowID	131
#define 	perlID	132
#define  helpID	133

#define  kLastID	helpID

#endif