/*********************************************************************
Project	:	MacPerl			-	Real Perl Application
File		:	MPWindow.h		-
Author	:	Matthias Neeracher

A lot of this code is borrowed from 7Edit written by
Apple Developer Support UK

Started	:	17Mar93								Language	:	MPW C
Modified	:	29May93	MN	Compiles correctly
				30May93	MN	Support Console Windows
				05Aug93	MN	Show window status
				24Aug93	MN	DoContent needs EventRecord *
Last		:	24Aug93
*********************************************************************/

#ifndef __MPWINDOW__
#define __MPWINDOW__

#include <Memory.h>
#include <Types.h>
#include <QuickDraw.h>
#include <Fonts.h>
#include <ToolUtils.h>
#include <Traps.h>
#include "MPGlobals.h"
#include "MPUtils.h"
#include "MPEditions.h"
#include "MPAppleEvents.h"

pascal DPtr DPtrFromWindowPtr(WindowPtr w);

pascal void MyGrowWindow(WindowPtr w,
                         Point     p);

pascal void DoZoom(WindowPtr w, short c, Point p);

pascal void DoContent(WindowPtr theWindow, EventRecord * theEvent);

pascal OSErr DoActivate(WindowPtr theWindow, Boolean   activate);

pascal void DoUpdate(DPtr theDoc);

pascal DPtr NewDocument(Boolean isForOldDoc, WindowKind kind);

pascal void CloseMyWindow(WindowPtr aWindow);

pascal void ShowSelect(DPtr theDoc);

pascal void AdjustScrollbars(DPtr theDoc, Boolean needsResize);

pascal void GetWinContentRect(WindowPtr theWindow, Rect *r);

pascal void ResizeWindow(DPtr theDoc);

pascal void ResizePageSetupForDocument(DPtr theDoc);

pascal void InvalidateDocument(DPtr theDoc);

pascal void DrawPageExtras(DPtr theDoc);

pascal void PrintWindow(DPtr theDoc, Boolean askUser);

pascal void ShowWindowStatus();

pascal void DoShowWindow(WindowPtr win);

pascal void DoHideWindow(WindowPtr win);

#endif